unit schFacturasProveedorClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_darReferencia = '{5A31B310-B21D-468B-963E-0BB3D56FF098}';
  RID_FacturasProveedor = '{7E2B16C4-976C-4809-9E04-2B6B5C91AF87}';
  RID_FacturasProveedor_Detalles = '{8A0BE5E9-157E-4CCC-8EF1-A29CDBA4E28A}';
  RID_FacturasProveedor_Detalles_Refresh = '{0DFFA036-18F8-4957-9991-669FC8EB4F42}';
  RID_FacturasProveedor_Refresh = '{3FA04195-2172-40A8-915E-9B961949C107}';

  { Data table names }
  nme_darReferencia = 'darReferencia';
  nme_FacturasProveedor = 'FacturasProveedor';
  nme_FacturasProveedor_Detalles = 'FacturasProveedor_Detalles';
  nme_FacturasProveedor_Detalles_Refresh = 'FacturasProveedor_Detalles_Refresh';
  nme_FacturasProveedor_Refresh = 'FacturasProveedor_Refresh';

  { darReferencia fields }
  fld_darReferenciaVALOR = 'VALOR';

  { darReferencia field indexes }
  idx_darReferenciaVALOR = 0;

  { FacturasProveedor fields }
  fld_FacturasProveedorID = 'ID';
  fld_FacturasProveedorID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasProveedorREFERENCIA = 'REFERENCIA';
  fld_FacturasProveedorTIPO = 'TIPO';
  fld_FacturasProveedorREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_FacturasProveedorFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasProveedorSITUACION = 'SITUACION';
  fld_FacturasProveedorBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasProveedorDESCUENTO = 'DESCUENTO';
  fld_FacturasProveedorIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasProveedorIVA = 'IVA';
  fld_FacturasProveedorIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasProveedorRE = 'RE';
  fld_FacturasProveedorIMPORTE_RE = 'IMPORTE_RE';
  fld_FacturasProveedorIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasProveedorOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasProveedorID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_FacturasProveedorNIF_CIF = 'NIF_CIF';
  fld_FacturasProveedorNOMBRE = 'NOMBRE';
  fld_FacturasProveedorCALLE = 'CALLE';
  fld_FacturasProveedorPOBLACION = 'POBLACION';
  fld_FacturasProveedorPROVINCIA = 'PROVINCIA';
  fld_FacturasProveedorCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasProveedorFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasProveedorFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasProveedorUSUARIO = 'USUARIO';
  fld_FacturasProveedorID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_FacturasProveedorRECARGO_EQUIVALENCIA = 'RECARGO_EQUIVALENCIA';
  fld_FacturasProveedorID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_FacturasProveedorIMPORTE_NETO = 'IMPORTE_NETO';
  fld_FacturasProveedorIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasProveedorFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';

  { FacturasProveedor field indexes }
  idx_FacturasProveedorID = 0;
  idx_FacturasProveedorID_EMPRESA = 1;
  idx_FacturasProveedorREFERENCIA = 2;
  idx_FacturasProveedorTIPO = 3;
  idx_FacturasProveedorREFERENCIA_PROVEEDOR = 4;
  idx_FacturasProveedorFECHA_FACTURA = 5;
  idx_FacturasProveedorSITUACION = 6;
  idx_FacturasProveedorBASE_IMPONIBLE = 7;
  idx_FacturasProveedorDESCUENTO = 8;
  idx_FacturasProveedorIMPORTE_DESCUENTO = 9;
  idx_FacturasProveedorIVA = 10;
  idx_FacturasProveedorIMPORTE_IVA = 11;
  idx_FacturasProveedorRE = 12;
  idx_FacturasProveedorIMPORTE_RE = 13;
  idx_FacturasProveedorIMPORTE_TOTAL = 14;
  idx_FacturasProveedorOBSERVACIONES = 15;
  idx_FacturasProveedorID_PROVEEDOR = 16;
  idx_FacturasProveedorNIF_CIF = 17;
  idx_FacturasProveedorNOMBRE = 18;
  idx_FacturasProveedorCALLE = 19;
  idx_FacturasProveedorPOBLACION = 20;
  idx_FacturasProveedorPROVINCIA = 21;
  idx_FacturasProveedorCODIGO_POSTAL = 22;
  idx_FacturasProveedorFECHA_ALTA = 23;
  idx_FacturasProveedorFECHA_MODIFICACION = 24;
  idx_FacturasProveedorUSUARIO = 25;
  idx_FacturasProveedorID_FORMA_PAGO = 26;
  idx_FacturasProveedorRECARGO_EQUIVALENCIA = 27;
  idx_FacturasProveedorID_TIPO_IVA = 28;
  idx_FacturasProveedorIMPORTE_NETO = 29;
  idx_FacturasProveedorIMPORTE_PORTE = 30;
  idx_FacturasProveedorFECHA_VENCIMIENTO = 31;

  { FacturasProveedor_Detalles fields }
  fld_FacturasProveedor_DetallesID = 'ID';
  fld_FacturasProveedor_DetallesID_FACTURA = 'ID_FACTURA';
  fld_FacturasProveedor_DetallesPOSICION = 'POSICION';
  fld_FacturasProveedor_DetallesTIPO_DETALLE = 'TIPO_DETALLE';
  fld_FacturasProveedor_DetallesCONCEPTO = 'CONCEPTO';
  fld_FacturasProveedor_DetallesCANTIDAD = 'CANTIDAD';
  fld_FacturasProveedor_DetallesIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_FacturasProveedor_DetallesDESCUENTO = 'DESCUENTO';
  fld_FacturasProveedor_DetallesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasProveedor_DetallesID_ARTICULO = 'ID_ARTICULO';
  fld_FacturasProveedor_DetallesVISIBLE = 'VISIBLE';
  fld_FacturasProveedor_DetallesIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasProveedor_DetallesREFERENCIA = 'REFERENCIA';
  fld_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { FacturasProveedor_Detalles field indexes }
  idx_FacturasProveedor_DetallesID = 0;
  idx_FacturasProveedor_DetallesID_FACTURA = 1;
  idx_FacturasProveedor_DetallesPOSICION = 2;
  idx_FacturasProveedor_DetallesTIPO_DETALLE = 3;
  idx_FacturasProveedor_DetallesCONCEPTO = 4;
  idx_FacturasProveedor_DetallesCANTIDAD = 5;
  idx_FacturasProveedor_DetallesIMPORTE_UNIDAD = 6;
  idx_FacturasProveedor_DetallesDESCUENTO = 7;
  idx_FacturasProveedor_DetallesIMPORTE_TOTAL = 8;
  idx_FacturasProveedor_DetallesID_ARTICULO = 9;
  idx_FacturasProveedor_DetallesVISIBLE = 10;
  idx_FacturasProveedor_DetallesIMPORTE_PORTE = 11;
  idx_FacturasProveedor_DetallesREFERENCIA = 12;
  idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR = 13;

  { FacturasProveedor_Detalles_Refresh fields }
  fld_FacturasProveedor_Detalles_RefreshID = 'ID';
  fld_FacturasProveedor_Detalles_RefreshID_FACTURA = 'ID_FACTURA';
  fld_FacturasProveedor_Detalles_RefreshPOSICION = 'POSICION';
  fld_FacturasProveedor_Detalles_RefreshTIPO_DETALLE = 'TIPO_DETALLE';
  fld_FacturasProveedor_Detalles_RefreshCONCEPTO = 'CONCEPTO';
  fld_FacturasProveedor_Detalles_RefreshCANTIDAD = 'CANTIDAD';
  fld_FacturasProveedor_Detalles_RefreshIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_FacturasProveedor_Detalles_RefreshDESCUENTO = 'DESCUENTO';
  fld_FacturasProveedor_Detalles_RefreshIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasProveedor_Detalles_RefreshID_ARTICULO = 'ID_ARTICULO';
  fld_FacturasProveedor_Detalles_RefreshVISIBLE = 'VISIBLE';
  fld_FacturasProveedor_Detalles_RefreshIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasProveedor_Detalles_RefreshREFERENCIA = 'REFERENCIA';
  fld_FacturasProveedor_Detalles_RefreshREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { FacturasProveedor_Detalles_Refresh field indexes }
  idx_FacturasProveedor_Detalles_RefreshID = 0;
  idx_FacturasProveedor_Detalles_RefreshID_FACTURA = 1;
  idx_FacturasProveedor_Detalles_RefreshPOSICION = 2;
  idx_FacturasProveedor_Detalles_RefreshTIPO_DETALLE = 3;
  idx_FacturasProveedor_Detalles_RefreshCONCEPTO = 4;
  idx_FacturasProveedor_Detalles_RefreshCANTIDAD = 5;
  idx_FacturasProveedor_Detalles_RefreshIMPORTE_UNIDAD = 6;
  idx_FacturasProveedor_Detalles_RefreshDESCUENTO = 7;
  idx_FacturasProveedor_Detalles_RefreshIMPORTE_TOTAL = 8;
  idx_FacturasProveedor_Detalles_RefreshID_ARTICULO = 9;
  idx_FacturasProveedor_Detalles_RefreshVISIBLE = 10;
  idx_FacturasProveedor_Detalles_RefreshIMPORTE_PORTE = 11;
  idx_FacturasProveedor_Detalles_RefreshREFERENCIA = 12;
  idx_FacturasProveedor_Detalles_RefreshREFERENCIA_PROVEEDOR = 13;

  { FacturasProveedor_Refresh fields }
  fld_FacturasProveedor_RefreshID = 'ID';
  fld_FacturasProveedor_RefreshID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasProveedor_RefreshREFERENCIA = 'REFERENCIA';
  fld_FacturasProveedor_RefreshTIPO = 'TIPO';
  fld_FacturasProveedor_RefreshREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_FacturasProveedor_RefreshFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasProveedor_RefreshSITUACION = 'SITUACION';
  fld_FacturasProveedor_RefreshBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasProveedor_RefreshDESCUENTO = 'DESCUENTO';
  fld_FacturasProveedor_RefreshIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasProveedor_RefreshIVA = 'IVA';
  fld_FacturasProveedor_RefreshIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasProveedor_RefreshRE = 'RE';
  fld_FacturasProveedor_RefreshIMPORTE_RE = 'IMPORTE_RE';
  fld_FacturasProveedor_RefreshIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasProveedor_RefreshOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasProveedor_RefreshID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_FacturasProveedor_RefreshNIF_CIF = 'NIF_CIF';
  fld_FacturasProveedor_RefreshNOMBRE = 'NOMBRE';
  fld_FacturasProveedor_RefreshCALLE = 'CALLE';
  fld_FacturasProveedor_RefreshPOBLACION = 'POBLACION';
  fld_FacturasProveedor_RefreshPROVINCIA = 'PROVINCIA';
  fld_FacturasProveedor_RefreshCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasProveedor_RefreshFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasProveedor_RefreshFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasProveedor_RefreshUSUARIO = 'USUARIO';
  fld_FacturasProveedor_RefreshID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_FacturasProveedor_RefreshRECARGO_EQUIVALENCIA = 'RECARGO_EQUIVALENCIA';
  fld_FacturasProveedor_RefreshID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_FacturasProveedor_RefreshIMPORTE_NETO = 'IMPORTE_NETO';
  fld_FacturasProveedor_RefreshIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasProveedor_RefreshFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';

  { FacturasProveedor_Refresh field indexes }
  idx_FacturasProveedor_RefreshID = 0;
  idx_FacturasProveedor_RefreshID_EMPRESA = 1;
  idx_FacturasProveedor_RefreshREFERENCIA = 2;
  idx_FacturasProveedor_RefreshTIPO = 3;
  idx_FacturasProveedor_RefreshREFERENCIA_PROVEEDOR = 4;
  idx_FacturasProveedor_RefreshFECHA_FACTURA = 5;
  idx_FacturasProveedor_RefreshSITUACION = 6;
  idx_FacturasProveedor_RefreshBASE_IMPONIBLE = 7;
  idx_FacturasProveedor_RefreshDESCUENTO = 8;
  idx_FacturasProveedor_RefreshIMPORTE_DESCUENTO = 9;
  idx_FacturasProveedor_RefreshIVA = 10;
  idx_FacturasProveedor_RefreshIMPORTE_IVA = 11;
  idx_FacturasProveedor_RefreshRE = 12;
  idx_FacturasProveedor_RefreshIMPORTE_RE = 13;
  idx_FacturasProveedor_RefreshIMPORTE_TOTAL = 14;
  idx_FacturasProveedor_RefreshOBSERVACIONES = 15;
  idx_FacturasProveedor_RefreshID_PROVEEDOR = 16;
  idx_FacturasProveedor_RefreshNIF_CIF = 17;
  idx_FacturasProveedor_RefreshNOMBRE = 18;
  idx_FacturasProveedor_RefreshCALLE = 19;
  idx_FacturasProveedor_RefreshPOBLACION = 20;
  idx_FacturasProveedor_RefreshPROVINCIA = 21;
  idx_FacturasProveedor_RefreshCODIGO_POSTAL = 22;
  idx_FacturasProveedor_RefreshFECHA_ALTA = 23;
  idx_FacturasProveedor_RefreshFECHA_MODIFICACION = 24;
  idx_FacturasProveedor_RefreshUSUARIO = 25;
  idx_FacturasProveedor_RefreshID_FORMA_PAGO = 26;
  idx_FacturasProveedor_RefreshRECARGO_EQUIVALENCIA = 27;
  idx_FacturasProveedor_RefreshID_TIPO_IVA = 28;
  idx_FacturasProveedor_RefreshIMPORTE_NETO = 29;
  idx_FacturasProveedor_RefreshIMPORTE_PORTE = 30;
  idx_FacturasProveedor_RefreshFECHA_VENCIMIENTO = 31;

type
  { IdarReferencia }
  IdarReferencia = interface(IDAStronglyTypedDataTable)
  ['{65EFF80E-72D6-4702-8DE2-EAB9E67C2CED}']
    { Property getters and setters }
    function GetVALORValue: String;
    procedure SetVALORValue(const aValue: String);


    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;
  end;

  { TdarReferenciaDataTableRules }
  TdarReferenciaDataTableRules = class(TDADataTableRules, IdarReferencia)
  private
  protected
    { Property getters and setters }
    function GetVALORValue: String; virtual;
    procedure SetVALORValue(const aValue: String); virtual;

    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasProveedor }
  IFacturasProveedor = interface(IDAStronglyTypedDataTable)
  ['{02E381CF-8B87-4CAC-BBB3-BE1303EFC6EA}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);
    function GetIMPORTE_REValue: Currency;
    procedure SetIMPORTE_REValue(const aValue: Currency);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetOBSERVACIONESValue: IROStrings;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetRECARGO_EQUIVALENCIAValue: Integer;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
  end;

  { TFacturasProveedorDataTableRules }
  TFacturasProveedorDataTableRules = class(TDADataTableRules, IFacturasProveedor)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;
    function GetIMPORTE_REValue: Currency; virtual;
    procedure SetIMPORTE_REValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetRECARGO_EQUIVALENCIAValue: Integer; virtual;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasProveedor_Detalles }
  IFacturasProveedor_Detalles = interface(IDAStronglyTypedDataTable)
  ['{09638FB4-2429-47C7-BEE6-695CCA2B7429}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);
    function GetIMPORTE_PORTEValue: Float;
    procedure SetIMPORTE_PORTEValue(const aValue: Float);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
  end;

  { TFacturasProveedor_DetallesDataTableRules }
  TFacturasProveedor_DetallesDataTableRules = class(TDADataTableRules, IFacturasProveedor_Detalles)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;
    function GetIMPORTE_PORTEValue: Float; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Float); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasProveedor_Detalles_Refresh }
  IFacturasProveedor_Detalles_Refresh = interface(IDAStronglyTypedDataTable)
  ['{34CAF884-E288-4691-BBB0-1FB65C392944}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);
    function GetIMPORTE_PORTEValue: Float;
    procedure SetIMPORTE_PORTEValue(const aValue: Float);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
  end;

  { TFacturasProveedor_Detalles_RefreshDataTableRules }
  TFacturasProveedor_Detalles_RefreshDataTableRules = class(TDADataTableRules, IFacturasProveedor_Detalles_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;
    function GetIMPORTE_PORTEValue: Float; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Float); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasProveedor_Refresh }
  IFacturasProveedor_Refresh = interface(IDAStronglyTypedDataTable)
  ['{9AC32D5C-9DDF-471B-95AA-FFC958A99C41}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);
    function GetIMPORTE_REValue: Currency;
    procedure SetIMPORTE_REValue(const aValue: Currency);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetOBSERVACIONESValue: IROStrings;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetRECARGO_EQUIVALENCIAValue: Integer;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
  end;

  { TFacturasProveedor_RefreshDataTableRules }
  TFacturasProveedor_RefreshDataTableRules = class(TDADataTableRules, IFacturasProveedor_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;
    function GetIMPORTE_REValue: Currency; virtual;
    procedure SetIMPORTE_REValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetRECARGO_EQUIVALENCIAValue: Integer; virtual;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TdarReferenciaDataTableRules }
constructor TdarReferenciaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TdarReferenciaDataTableRules.Destroy;
begin
  inherited;
end;

function TdarReferenciaDataTableRules.GetVALORValue: String;
begin
  result := DataTable.Fields[idx_darReferenciaVALOR].AsString;
end;

procedure TdarReferenciaDataTableRules.SetVALORValue(const aValue: String);
begin
  DataTable.Fields[idx_darReferenciaVALOR].AsString := aValue;
end;


{ TFacturasProveedorDataTableRules }
constructor TFacturasProveedorDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasProveedorDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasProveedorDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_EMPRESA].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_EMPRESA].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorREFERENCIA].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorREFERENCIA].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorTIPO].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorTIPO].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasProveedorDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorSITUACION].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorSITUACION].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorBASE_IMPONIBLE].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedorDESCUENTO].AsFloat;
end;

procedure TFacturasProveedorDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedorDESCUENTO].AsFloat := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedorIVA].AsFloat;
end;

procedure TFacturasProveedorDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedorIVA].AsFloat := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_IVA].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_IVA].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedorRE].AsFloat;
end;

procedure TFacturasProveedorDataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedorRE].AsFloat := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_REValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_RE].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_REValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_RE].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasProveedorOBSERVACIONES].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasProveedorOBSERVACIONES].AsString := aValue.Text;
end;

function TFacturasProveedorDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_PROVEEDOR].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_PROVEEDOR].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorNIF_CIF].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorNIF_CIF].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorNOMBRE].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorNOMBRE].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorCALLE].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorCALLE].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorPOBLACION].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorPOBLACION].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorPROVINCIA].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorPROVINCIA].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorCODIGO_POSTAL].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_ALTA].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasProveedorDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedorUSUARIO].AsString;
end;

procedure TFacturasProveedorDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedorUSUARIO].AsString := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_FORMA_PAGO].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_FORMA_PAGO].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetRECARGO_EQUIVALENCIAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorRECARGO_EQUIVALENCIA].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorRECARGO_EQUIVALENCIA].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedorID_TIPO_IVA].AsInteger;
end;

procedure TFacturasProveedorDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedorID_TIPO_IVA].AsInteger := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_NETO].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_NETO].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedorIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasProveedorDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedorIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasProveedorDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedorFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasProveedorDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedorFECHA_VENCIMIENTO].AsDateTime := aValue;
end;


{ TFacturasProveedor_DetallesDataTableRules }
constructor TFacturasProveedor_DetallesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasProveedor_DetallesDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesID].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID_FACTURA].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesID_FACTURA].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesPOSICION].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesPOSICION].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesTIPO_DETALLE].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesTIPO_DETALLE].AsString := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesCONCEPTO].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesCONCEPTO].AsString := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesCANTIDAD].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesCANTIDAD].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_UNIDAD].AsCurrency;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesDESCUENTO].AsFloat;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesDESCUENTO].AsFloat := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesID_ARTICULO].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesID_ARTICULO].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesVISIBLE].AsInteger;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesVISIBLE].AsInteger := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetIMPORTE_PORTEValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_PORTE].AsFloat;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetIMPORTE_PORTEValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesIMPORTE_PORTE].AsFloat := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA].AsString := aValue;
end;

function TFacturasProveedor_DetallesDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasProveedor_DetallesDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_DetallesREFERENCIA_PROVEEDOR].AsString := aValue;
end;


{ TFacturasProveedor_Detalles_RefreshDataTableRules }
constructor TFacturasProveedor_Detalles_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasProveedor_Detalles_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshID].AsInteger;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshID].AsInteger := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshID_FACTURA].AsInteger;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshID_FACTURA].AsInteger := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshPOSICION].AsInteger;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshPOSICION].AsInteger := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshTIPO_DETALLE].AsString;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshTIPO_DETALLE].AsString := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshCONCEPTO].AsString;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshCONCEPTO].AsString := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshCANTIDAD].AsInteger;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshCANTIDAD].AsInteger := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshIMPORTE_UNIDAD].AsCurrency;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshDESCUENTO].AsFloat;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshDESCUENTO].AsFloat := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshID_ARTICULO].AsInteger;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshID_ARTICULO].AsInteger := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshVISIBLE].AsInteger;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshVISIBLE].AsInteger := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetIMPORTE_PORTEValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshIMPORTE_PORTE].AsFloat;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetIMPORTE_PORTEValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshIMPORTE_PORTE].AsFloat := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshREFERENCIA].AsString;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshREFERENCIA].AsString := aValue;
end;

function TFacturasProveedor_Detalles_RefreshDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasProveedor_Detalles_RefreshDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_Detalles_RefreshREFERENCIA_PROVEEDOR].AsString := aValue;
end;


{ TFacturasProveedor_RefreshDataTableRules }
constructor TFacturasProveedor_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasProveedor_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshID].AsInteger;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshID].AsInteger := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshID_EMPRESA].AsInteger;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshID_EMPRESA].AsInteger := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshREFERENCIA].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshREFERENCIA].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshTIPO].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshTIPO].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshSITUACION].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshSITUACION].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshBASE_IMPONIBLE].AsCurrency;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshDESCUENTO].AsFloat;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshDESCUENTO].AsFloat := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshIVA].AsFloat;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshIVA].AsFloat := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_IVA].AsCurrency;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_IVA].AsCurrency := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshRE].AsFloat;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshRE].AsFloat := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIMPORTE_REValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_RE].AsCurrency;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIMPORTE_REValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_RE].AsCurrency := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasProveedor_RefreshOBSERVACIONES].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshOBSERVACIONES].AsString := aValue.Text;
end;

function TFacturasProveedor_RefreshDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshID_PROVEEDOR].AsInteger;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshID_PROVEEDOR].AsInteger := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshNIF_CIF].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshNIF_CIF].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshNOMBRE].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshNOMBRE].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshCALLE].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshCALLE].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshPOBLACION].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshPOBLACION].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshPROVINCIA].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshPROVINCIA].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshCODIGO_POSTAL].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_ALTA].AsDateTime;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshUSUARIO].AsString;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshUSUARIO].AsString := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshID_FORMA_PAGO].AsInteger;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshID_FORMA_PAGO].AsInteger := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetRECARGO_EQUIVALENCIAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshRECARGO_EQUIVALENCIA].AsInteger;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshRECARGO_EQUIVALENCIA].AsInteger := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshID_TIPO_IVA].AsInteger;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshID_TIPO_IVA].AsInteger := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_NETO].AsCurrency;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_NETO].AsCurrency := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasProveedor_RefreshDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasProveedor_RefreshDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasProveedor_RefreshFECHA_VENCIMIENTO].AsDateTime := aValue;
end;


initialization
  RegisterDataTableRules(RID_darReferencia, TdarReferenciaDataTableRules);
  RegisterDataTableRules(RID_FacturasProveedor, TFacturasProveedorDataTableRules);
  RegisterDataTableRules(RID_FacturasProveedor_Detalles, TFacturasProveedor_DetallesDataTableRules);
  RegisterDataTableRules(RID_FacturasProveedor_Detalles_Refresh, TFacturasProveedor_Detalles_RefreshDataTableRules);
  RegisterDataTableRules(RID_FacturasProveedor_Refresh, TFacturasProveedor_RefreshDataTableRules);

end.
